#include <glib.h>
#include <glib-object.h>

#include <dbus/dbus-protocol.h>
#include <dbus/dbus-glib.h>
#include <dbus/dbus-glib-bindings.h>

#include "speech-server.h"

#define		_PROXY_SERVICE_NAME	"org.laptop.Speech"
#define		_PROXY_OBJECT_PATH	"/org/laptop/Speech"	
#define		_PROXY_GTYPE		SPEECH_SERVER_TYPE

extern debug;
extern default_flag;

static gboolean register_server ()
{
	DBusGConnection * connection;
	DBusGProxy * proxy;
	GError * error = NULL;
	guint32 request_name_ret;

	connection = dbus_g_bus_get (DBUS_BUS_SESSION, &error);

	if (connection == NULL)
    	{
        	g_warning("%s\n", error->message);
        	g_error_free(error);
		return FALSE;
	}

	proxy = dbus_g_proxy_new_for_name (connection,
					   DBUS_SERVICE_DBUS,
					   DBUS_PATH_DBUS,
					   DBUS_INTERFACE_DBUS);

	if (! org_freedesktop_DBus_request_name (proxy, _PROXY_SERVICE_NAME,
						0, &request_name_ret, &error))
    	{
        	g_warning("%s\n", error->message);
        	g_error_free(error);	
    		return FALSE;
	}

	if (request_name_ret != DBUS_REQUEST_NAME_REPLY_PRIMARY_OWNER) 
		return FALSE;
	
	dbus_g_connection_register_g_object (connection, _PROXY_OBJECT_PATH, 
					     g_object_new (_PROXY_GTYPE, NULL));
	return TRUE;
}

int main(int argc, char ** argv)
{

	
    	if(argc > 1){
		if(argv[1][0] == '-'){
			if(argv[1][1] == 'd')
				debug = 1;
		}
	}

    	GMainLoop * loop = g_main_loop_new(NULL, FALSE);

	g_type_init();
	g_set_prgname(argv[0]);

	if(! register_server())
		g_error("Couldn't register service on the session bus!\n");
    
    	g_main_loop_run(loop);
    
    	return 0;
}

