#!/usr/bin/env python
# Copyright (C) 2007 J. Cody Lodrige.
# All Rights Reserved.
#
# Orginally taken from the Python GTK example, "getselection.py"
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software

import pygtk
pygtk.require('2.0')
import gtk
import os, subprocess
import dbus
import dbus.service

def on_speak(clipboard, text, proxy):
	proxy.SayText(text)

def on_clicked(button, data):
	gtk.clipboard_get(selection = "PRIMARY").request_text(on_speak, data)

def main():
	bus = dbus.SessionBus()	
	espeak_object = bus.get_object('org.laptop.Speech','/org/laptop/Speech')
	
	window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        window.set_title("Get Selection")
        window.set_border_width(10)
        window.connect("destroy", lambda w: gtk.main_quit())

        button = gtk.Button("Speak Selection")
	button.connect("clicked", on_clicked, espeak_object)
	window.add(button)

        window.show_all()
   
 	gtk.main()

if __name__ == "__main__":
	main()


