#!/usr/bin/env python
# Copyright (C) 2007 J. Cody Lodrige.
# All Rights Reserved.
#
# Async test of sugar-speechd
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software

import dbus
import dbus.service
from dbus.mainloop.glib import DBusGMainLoop
import gobject

def on_err(exc):
	print exc
	loop.quit()

def call_proxy_async(proxy, text):
	proxy.SayText(text, reply_handler = lambda: None, error_handler = on_err)

def main():
	bus = dbus.SessionBus(mainloop = DBusGMainLoop())	
	proxy = bus.get_object('org.laptop.Speech','/org/laptop/Speech')
	# work
	call_proxy_async(proxy, "Hello World!")
	# fail
	call_proxy_async(proxy, "Hello World!" * 1000)

if __name__ == "__main__":
	global loop	
	loop = gobject.MainLoop()	
	main()
	loop.run()

